#include <Adafruit_NeoPixel.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include "DHT.h"
#define DHTPIN 2     
#define DHTTYPE DHT11
#define PIN         3
#define NUM_LEDS   16
LiquidCrystal_I2C lcd(0x27,16,2);
DHT dht(DHTPIN, DHTTYPE);

const int buttonPin = 9;
int buttonState     = 0;
int lastButtonState = 0;
int modo = 0;
int sonido = 8;
int rojo = A1;
int verde = A2;
int azul = A3;
int valorrojo;
float vr;
int valorverde;
float vv;
int valorazul;
float va;
int modo2 = 0;
int sonidoprevio = 0;
int valorsonido = 0;
double vr1 = 0;
double vv1 = 0;
double va1 = 0;
int contador = 0;
int foto= A0;
int valorfoto;


Adafruit_NeoPixel pixels(NUM_LEDS, PIN, NEO_GRB + NEO_KHZ800);

//Se definen todas la variables que se utilizarán, los pines digitales y analógicos de los sensores o modulos y algunos valores de entrada de las funciones de las librerías correspondientes



void setup() {
  pixels.begin();
  pixels.show();
  Serial.begin(9600);
  pixels.begin();
  pinMode(rojo, INPUT);
  pinMode(verde, INPUT);
  pinMode(azul, INPUT);
  pinMode(buttonPin, INPUT);
  pinMode(sonido, INPUT);
  lcd.init();                      
  lcd.backlight();
  Serial.begin(9600);
  Serial.println(F("DHTxx test!"));
  dht.begin();
}
// Se inicializan algunas funciones importantes y el puerto serial

void loop() {
  
  buttonState = digitalRead(buttonPin); // lectura digital del push button 

  if (buttonState == HIGH && lastButtonState == LOW) {
    if (modo == 0) {
      modoManual();
      modo = 1;
    } else {
      modoAutomatico();
      modo = 0;
    }
  }
  if (modo == 1){
    modoManual();
  } else {
    modoAutomatico();
  }
  
  lastButtonState = buttonState;
}

// Estructura lógica para el loop principal del programa en base a los modos de la lámpara

void modoManual() {
      valorsonido= digitalRead(sonido); //Lectura digital del sensor de sonido en base a un contador
      if (valorsonido == HIGH){
        contador++;
      }
      Serial.println(contador); // verificación del funcionamiento del sensor de sonido por medio del puerto serial
      if (contador!=0){
          if (modo2 == 0){
            lcd.clear();
             vr = 0;
          vv = 0;
          va = 0;
          for ( int i = 0; i < 255; i++){ // ciclo de definición de los colores de la lámpara para el modo neutral
          vr++;
          vv++;
          va++;
          valorsonido= digitalRead(sonido);
          if (valorsonido == HIGH){
              contador++;
          }
          for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
              pixels.setPixelColor(i, pixels.Color(vr, vv, va)); 
              pixels.show();
              valorsonido= digitalRead(sonido);
          if (valorsonido == HIGH){
              contador++;
          }
          }
          }
            modo2 = 1;
          } else { //Definición del modo manual para el registro de cambio de los colores de los potenciómetros
            lcd.clear();
            lcd.setCursor(0,0);
            lcd.print("MANUAL");
            valorrojo = analogRead(rojo);  
            vr = (255./1023.) * valorrojo; 
            valorverde = analogRead(verde);  
            vv = (255./1023.) * valorverde; 
            valorazul = analogRead(azul);  
            va = (255./1023.) * valorazul;
            //pixels.clear();
            for (int i = 0; i < 16; i++) {  //ciclo de cambio de color de los neopixeles
              pixels.setPixelColor(i, pixels.Color(vr, vv, va)); 
              pixels.show();
            }
            modo2 = 0;
          }
          contador = 0; //reinicio del contador
        }
      if (modo2 == 1){
        lcd.clear();
        vr = 0;
        vv = 0;
        va = 0;
        for ( int i = 0; i < 255; i++){ // ciclo de definición de los colores de la lámpara para el modo neutral
          vr++;
          vv++;
          va++;
          valorsonido= digitalRead(sonido); //lectura digital del sensor de sonido
          if (valorsonido == HIGH){
              contador++;
          }
          for (int i = 0; i < 16; i++) {  //ciclo de cambio de color de los neopixeles
              pixels.setPixelColor(i, pixels.Color(vr, vv, va)); 
              pixels.show();
          valorsonido= digitalRead(sonido);
          if (valorsonido == HIGH){
              contador++;
          }
              
          }
          
        }
       
       
   
      } else {
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("MANUAL");
          valorrojo = analogRead(rojo);  
          vr = (255./1023.) * valorrojo; 
          valorverde = analogRead(verde);  
          vv = (255./1023.) * valorverde; 
          valorazul = analogRead(azul);  
          va = (255./1023.) * valorazul;
          //pixels.clear();
          for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
            pixels.setPixelColor(i, pixels.Color(vr, vv, va)); 
            pixels.show();
          }
      } 
      sonidoprevio = valorsonido;  
}

//Estructura lógica para el cambio de modos dentro del modo manual

void modoAutomatico() { //Definición del modo manual 
  delay(2000); // delay para la toma de valores
  valorfoto= analogRead(foto);
  float h = dht.readHumidity(); //lectura de humedad
  float t = dht.readTemperature(); //lectura de tempetatura en celsius
  float f = dht.readTemperature(true); //lectura de temperatura en farenheit
  if (isnan(h) || isnan(t) || isnan(f)) { //Validación de toma correcta de datos
    Serial.println(F("Failed to read from DHT sensor!"));
    return; 
  }

  float hif = dht.computeHeatIndex(f, h);
  float hic = dht.computeHeatIndex(t, h, false);

  Serial.print(F("Humidity: "));
  Serial.print(h);
  Serial.print(F("%  Temperature: "));
  Serial.print(t);
  Serial.print(F("°C "));
  Serial.print(f);
  Serial.print(F("°F  Heat index: "));
  Serial.print(hic);
  Serial.print(F("°C "));
  Serial.print(hif);
  Serial.println(F("°F")); 
  valorfoto= analogRead(foto);
// Presentación de datos en monitor serial

  lcd.setCursor(0,0);
  lcd.print("Temp: ");
  lcd.print(t);
  lcd.setCursor(0,1);
  lcd.print("Humedad: ");
  lcd.print(h);
// Representación de la información en la pantalla LCD

  if (t>21 and t<22){
    vr1 = 0;
    vv1 = 0;
    va1 = 255;
  } else if (t>22 and t <23){
    vr1 = 0;
    vv1 = 150;
    va1 = 255;
  } else if (t>23 and t<24){
    vr1 = 0;
    vv1 = 254;
    va1 = 255;
  } else if (t>24 and t<25){
    vr1 = 0;
    vv1 = 255;
    va1 = 150;
  } else if (t>25 and t<26){
    vr1 = 0;
    vv1 = 255;
    va1 = 0;
  } else if (t>26 and t<27){
    vr1 = 150;
    vv1 = 255;
    va1 = 0;
  } else if (t>27 and t<28){
    vr1 = 255;
    vv1 = 254;
    va1 = 0;
  } else if (t>28 and t<29){
    vr1 = 255;
    vv1 = 150;
    va1 = 0;
  } else if (t>29){
    vr1 == 255;
    vv1 == 0;
    va1 == 0;
  }
  valorfoto= analogRead(foto);
  Serial.println(valorfoto);
  if (valorfoto< 40){
    vr1 = vr1*0.6;
    vv1 = vv1*0.6;
    va1 = va1*0.6;
  }
//Definición de colores según los rangos de temperatura registrados

  
  for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(vr1, vv1, va1)); 
    pixels.show();
  }
}
